/********************************** (C) COPYRIGHT *********************************
* File Name          : DNS.C
* Author             : WCH
* Version            : V1.1
* Date               : 2020/02/19
* Description        :DNSӿļ
**********************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "sys.h"
#include "dns.h"
#include "CH392CMD.h"
#include "CH392.h"
#include "CH392INC.h"

UINT8 DNS_SERVER_IP[4]={192,168,0,1};                                                   /*DNSʵDNS޸*/
UINT16 MSG_ID = 0x1100;                                                                
UINT8 dns_buf[MAX_DNS_BUF_SIZE];
UINT8 status;
UINT16 count = 0;
 extern UINT16 Socket0SourPort ;
 extern struct  _SOCK_INF   SockInf[2];
 extern struct  _CH395_SYS  CH395Inf; 

/*********************************************************************************
* Function Name  : get16
* Description    : UINT8תΪUINT16ʽ
* Input          : UINT8 
* Output         : None
* Return         : תUINT16
**********************************************************************************/
UINT16 get16(UINT8 * s)
{
	UINT16 i;
	i = *s++ << 8;
	i = i + *s;
	return i;
}

/**********************************************************************************
* Function Name  : ParseName
* Description    : 
* Input          : msg            -ָĵָ
                   compressed    -ָָ
                   buf            -ָ룬ڴת
* Output         : None
* Return         : ѹĵĳ
**********************************************************************************/
int ParseName(UINT8 * msg, UINT8 * compressed, char * buf)
{
	UINT16 slen;                                                                            /* ǰƬγ*/
	UINT8 * cp;
	int clen = 0;                                                                           /* ѹ */
	int indirect = 0;
	int nseg = 0;                                                                           /* ָƬ */
	cp = compressed;
	for (;;)
	{
	slen = *cp++;                                                                          /* ֽڵļֵ*/
	if (!indirect) clen++;
	if ((slen & 0xc0) == 0xc0)                                                             /*ֽڸΪ1ѹʽ*/
	{
	  if (!indirect)
		clen++;
		indirect = 1;
		cp = &msg[((slen & 0x3f)<<8) + *cp];                                              /*ֵָֽƫƵָλ*/
		slen = *cp++;
	} 
	if (slen == 0)                                                                        /*Ϊ0*/
		break;
	if (!indirect) clen += slen;
	while (slen-- != 0) *buf++ = (char)*cp++;
	*buf++ = '.';
	nseg++;
	}
	if (nseg == 0)
	{
	 *buf++ = '.';
	}
	*buf++ = '\0';
	return clen;                                                                            /*ѹĳ */
}

/*********************************************************************************
* Function Name  : DnsQuestion
* Description    : Ӧе¼
* Input          : msg          -ָӦĵָ
                   cp           -ָ¼ָ
* Output         : None
* Return         :ָһ¼ָ
**********************************************************************************/
UINT8 * DnsQuestion(UINT8 * msg, UINT8 * cp)
{
	int len;
	char name[MAX_DNS_BUF_SIZE];
	len = ParseName(msg, cp, name);
	cp += len;
	cp += 2;                                                                                  /*  */
	cp += 2;                                                                                  /*  */
	return cp;
}

/*********************************************************************************
* Function Name  : DnsAnswer
* Description    : ӦеĻش¼
* Input          : msg            -ָӦĵָ
                   cp             -ָش¼ָ
                   psip           
* Output         : None
* Return         :ָһ¼ָ
**********************************************************************************/
UINT8 * DnsAnswer(UINT8 * msg, UINT8 * cp, UINT8 * pSip)
{
	int len, type;
	char name[MAX_DNS_BUF_SIZE];
	len = ParseName(msg, cp, name);
	cp += len;
	type = get16(cp);
	cp += 2;                                                                                   /*  */
	cp += 2;                                                                                   /*  */
	cp += 4;                                                                                   /* ʱ */
	cp += 2;                                                                                   /* Դݳ */
	switch (type)
	{
	case TYPE_A:
	pSip[0] = *cp++;
	pSip[1] = *cp++;
	pSip[2] = *cp++;
	pSip[3] = *cp++;
	break;
	case TYPE_CNAME:
	case TYPE_MB:
	case TYPE_MG:
	case TYPE_MR:
	case TYPE_NS:
	case TYPE_PTR:
	len = ParseName(msg, cp, name);
	cp += len;
	break;
	case TYPE_HINFO:

	case TYPE_MX:

	case TYPE_SOA:

	case TYPE_TXT:
	break;
	default:
	break;
	}
	return cp;
}
/*********************************************************************************
* Function Name  : parseMSG
* Description    : ӦеԴ¼
* Input          : msg            -ָDNSͷָ
                   cp             -ָӦĵָ
                   pSip
* Output         : None
* Return         :ɹ1򷵻0
**********************************************************************************/
UINT8 parseMSG(struct dhdr * pdhdr, UINT8 * pbuf, UINT8 * pSip)
{
	UINT16 tmp;
	UINT16 i;
	UINT8 * msg;
	UINT8 * cp;
	msg = pbuf;
	memset(pdhdr, 0, sizeof(pdhdr));
	pdhdr->id = get16(&msg[0]);
	tmp = get16(&msg[2]);
	if (tmp & 0x8000) pdhdr->qr = 1;
	pdhdr->opcode = (tmp >> 11) & 0xf;
	if (tmp & 0x0400) pdhdr->aa = 1;
	if (tmp & 0x0200) pdhdr->tc = 1;
	if (tmp & 0x0100) pdhdr->rd = 1;
	if (tmp & 0x0080) pdhdr->ra = 1;
	pdhdr->rcode = tmp & 0xf;
	pdhdr->qdcount = get16(&msg[4]);
	pdhdr->ancount = get16(&msg[6]);
	pdhdr->nscount = get16(&msg[8]);
	pdhdr->arcount = get16(&msg[10]);
	/* ɱݳȲ*/
	cp = &msg[12];
	for (i = 0; i < pdhdr->qdcount; i++)                                                      /* ѯ */
	{
	cp = DnsQuestion(msg, cp);
	}  
	for (i = 0; i < pdhdr->ancount; i++)                                                      /* ش */
	{
	cp = DnsAnswer(msg, cp, pSip);
	}
	for (i = 0; i < pdhdr->nscount; i++)                                                      /*Ȩ */
	{
	/**/  ;
	}  
	for (i = 0; i < pdhdr->arcount; i++)                                                      /* Ϣ */
	{
	/**/  ;
	}
	if(pdhdr->rcode == 0) return 1;                                                           /*rcode = 0:ɹ*/
	else return 0;
}

/*********************************************************************************
* Function Name  : put16
* Description    :UINT16 ʽݰUINT8ʽ浽
* Input          : s -׵ַ
                   i -UINT16
* Output         : None
* Return         : ƫָ
**********************************************************************************/
UINT8 * put16(UINT8 * s, UINT16 i)
{
	*s++ = i >> 8;
	*s++ = i;
	return s;
}

/**********************************************************************************
* Function Name  : MakeDnsQuery
* Description    : DNSѯ
  input          : op   - ݹ
*                  name - ָָ
*                  buf  - DNS.
*                  len  - 󳤶.
* Output         : None
* Return         : ָDNSָ
**********************************************************************************/
UINT16 MakeDnsQueryMsg(UINT16 op, char * name, UINT8 * buf, UINT16 len)
{
	UINT8 *cp;
	char *cp1;
	char tmpname[MAX_DNS_BUF_SIZE];
	char *dname;
	UINT16 p;
	UINT16 dlen;
	cp = buf;
	MSG_ID++;
	cp = put16(cp, MSG_ID);                                                                 /*ʶ*/
	p = (op << 11) | 0x0100;      
	cp = put16(cp, p);                                                                      /* 0x0100Recursion desired */
	cp = put16(cp, 1);                                                                      /*1*/
	cp = put16(cp, 0);                                                                      /*Դ¼0*/
	cp = put16(cp, 0);                                                                      /*Դ¼0*/
	cp = put16(cp, 0);                                                                      /*Դ¼0*/
	strcpy(tmpname, name);
	dname = tmpname;
	dlen = strlen(dname);
	for (;;)
	{                                                                                        /*DNSʽURIд뵽bufȥ*/
	cp1 = strchr(dname, '.');
	if (cp1 != NULL) len = cp1 - dname;  
	else len = dlen;    
	*cp++ = len;      
	if (len == 0) break;    
	strncpy((char *)cp, dname, len);
	cp += len;
	if (cp1 == NULL)
	{
	  *cp++ = 0;    
	  break;
	}
	dname += len+1;                                                                        /*dname׵ַ*/
	dlen -= len+1;                                                                         /*dnameȼС*/
	}
	cp = put16(cp, 0x0001);                                                                  /* type 1------ipַ*/
	cp = put16(cp, 0x0001);                                                                  /* class 1-------ַ*/
	return ((UINT16)(cp - buf));
}

void UDPSocketParamInit(UINT8 sockindex,UINT8 *addr,UINT16 SourPort,UINT16 DesPort)
{
	UINT8 i;
	memset(&SockInf[sockindex],0,sizeof(SockInf[sockindex]));        /* SockInf[0]ȫ*/
	memcpy(SockInf[sockindex].IPAddr,addr,sizeof(addr));             /* ĿIPַд */
	SockInf[sockindex].DesPort = DesPort;                            /* ĿĶ˿ */
	SockInf[sockindex].SourPort = SourPort;                          /* Դ˿ */
	SockInf[sockindex].ProtoType = PROTO_TYPE_UDP; 

	CH392SetSocketDesIP(sockindex,SockInf[sockindex].IPAddr);        /* socket 0ĿIPַ */         
	CH392SetSocketProtType(sockindex,PROTO_TYPE_UDP);                /* socket 0Э */
	CH392SetSocketDesPort(sockindex,SockInf[sockindex].DesPort);     /* socket 0ĿĶ˿ */
	CH392SetSocketSourPort(sockindex,SockInf[sockindex].SourPort);   /* socket 0Դ˿ */
	i = CH392OpenSocket(sockindex);                                  /* socket 0 */
	mStopIfError(i);  
}

/*********************************************************************************
* Function Name  : UDPSendData
* Description    : UDPʽ
* Input          : sockindexdatabuflen
* Output         : None
* Return         : None
**********************************************************************************/
UINT16 UDPSendData(UINT8 sockindex,UINT8 *databuf,UINT16 len)
{
	UINT16 ret;
	if(len>512){
	ret = 512;
	}
	else ret =len;
	CH392SendData(sockindex,databuf,len); 
	return ret;
}

/***********************************************************************************
* Function Name  : DnsQuery
* Description    : DNSѯ
  input          : s    -socket
*                  name - ָָ
                   pSip -ѯ
* Output         : None
* Return         : ѯɹ1ʧܷ-1
**********************************************************************************/
UINT8 DnsQuery(UINT8 s, UINT8 * name, UINT8 * pSip)
{
	struct dhdr dhp;
	UINT16 len,cnt;
	if(status>1)
	{
		count++;
		printf("count = %2d\n",(UINT16)count);
		delay_ms(1);
		if(count>2000)
		{
			printf("DNS Fail!!!!\n");
			count =0;
			status =0;
		}
	}
	if(status == 1)
	{
		UDPSocketParamInit(s,DNS_SERVER_IP,Socket0SourPort,IPPORT_DOMAIN);
		status = 2;
		printf("status = 2!\n");
	}
	if(status ==2)
	{
		len = MakeDnsQueryMsg(0,(char *)name, dns_buf, MAX_DNS_BUF_SIZE);
		cnt = UDPSendData(s,dns_buf,len);
		if (cnt == 0) return(0); 
		else
		{
			status = 3;
			printf("status = 3!\n");
		}
	}
	if(status ==4)
	{
		return(parseMSG(&dhp, dns_buf, pSip));                                                 
	}
	return 0;
}

