/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/02/19
* Description        : Main program body.
*******************************************************************************/ 
#include "delay.h"
#include "sys.h"
#include "usart.h"
#include "string.h"
#include "stdio.h"
#include "CH392INC.h"
#include "CH392.H"
#include "DNS.h"

#define Query392Interrupt()  PAin(0) 

/***********************************************************************************/
/*CH392_OP_INTERFACE_MODEΪ1-2
1ӷʽ
2spiӷʽ  */

#define   CH392_OP_INTERFACE_MODE           1                   
#if   (CH392_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "CH392UART.C"                                           
#elif (CH392_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "CH392SPI_HW.C"                                            
#else
#error "Please Select Correct Communication Interface "
#endif

/**********************************************************************************/
/* ļ */
#include "CH392CMD.C"

#define MAX_URL_SIZE                            128

UINT8  url_dn1[MAX_URL_SIZE] = "www.baidu.com";    
UINT8  url_dn2[MAX_URL_SIZE] = "www.google.com";    
UINT8  url_dn3[MAX_URL_SIZE] = "www.wch.cn";    

/* ñ */
UINT8  MyBuffer[4096];                                             /* ݻ */
struct _SOCK_INF  SockInf;                                         /* SocketϢ */
struct _CH392_SYS  CH392Inf;                                       /* CH392Ϣ */

/* CH392ض */
const UINT8 CH392IPAddr[4] = {192,168,1,10};                       /* CH392IPַ */
const UINT8 CH392GWIPAddr[4] = {192,168,1,1};                      /* CH392 */
const UINT8 CH392IPMask[4] = {255,255,255,0};                      /* CH392 */

/* socket ض*/
const UINT8  Socket0DesIP[4] = {255,255,255,255};                    /* Socket 0ĿIPַ */
const UINT16 Socket0SourPort = 5000;                               /* Socket 0Դ˿ */
const UINT16 Socket0DesPort   = 1000;                              /* Socket 0ĿĶ˿ */
/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(UINT8 iError)
{
	if (iError == CMD_ERR_SUCCESS) return;                           /* ɹ */
	printf("Error: %02X\r\n", (UINT16)iError);                         /* ʾ */
	while ( 1 ) 
	{
	delay_ms(200);
	delay_ms(200);
	}
}

/**********************************************************************************
* Function Name  : InitCH392InfParam
* Description    : ʼCH392Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH392InfParam(void)
{
    memset(&CH392Inf,0,sizeof(CH392Inf));                            /* CH392Infȫ*/
    memcpy(CH392Inf.IPAddr,CH392IPAddr,sizeof(CH392IPAddr));         /* IPַдCH392Inf */
    memcpy(CH392Inf.GWIPAddr,CH392GWIPAddr,sizeof(CH392GWIPAddr));   /* IPַдCH392Inf */
    memcpy(CH392Inf.MASKAddr,CH392IPMask,sizeof(CH392IPMask));       /* дCH392Inf */
}

/**********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam(void)
{
    memset(&SockInf,0,sizeof(SockInf));                              /* SockInf[0]ȫ*/
    memcpy(SockInf.IPAddr,Socket0DesIP,sizeof(Socket0DesIP));        /* ĿIPַд */
    SockInf.DesPort = Socket0DesPort;                                /* ĿĶ˿ */
    SockInf.SourPort = Socket0SourPort;                              /* Դ˿ */
    SockInf.ProtoType = PROTO_TYPE_UDP;                              /* TCPģʽ */
}

/**********************************************************************************
* Function Name  : CH392SocketInitOpen
* Description    : CH392 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH392SocketInitOpen(void)
{
    UINT8 i;

    /* socket 0ΪTCP ģʽ */
    CH392SetSocketDesIP(0,SockInf.IPAddr);                           /* socket 0ĿIPַ */         
    CH392SetSocketProtType(0,SockInf.ProtoType);                     /* socket 0Э */
    CH392SetSocketDesPort(0,SockInf.DesPort);                        /* socket 0ĿĶ˿ */
    CH392SetSocketSourPort(0,SockInf.SourPort);                      /* socket 0Դ˿ */
    i = CH392OpenSocket(0);                                          /* socket 0 */
    mStopIfError(i);                                                 /* Ƿɹ */
}

/**********************************************************************************
* Function Name  : CH392SocketInterrupt
* Description    : CH392 socket ж,ȫжб
* Input          : sockindex
* Output         : None
* Return         : None
**********************************************************************************/
void CH392SocketInterrupt(UINT8 sockindex)
{
   UINT8  sock_int_socket;
   UINT16 len;
   u16 i;

   sock_int_socket = CH392GetSocketInt(sockindex);                   /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {
   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
       len = CH392GetRecvLength(sockindex);                          /* ȡǰݳ */
       printf("receive len = %d\r\n",len);
		  CH392GetRecvData(sockindex,len,MyBuffer);
		  for(i=0;i<len;i++)
			printf("%x ",MyBuffer[i]);
   }
   if(sock_int_socket & SINT_STAT_CONNECT)                          /* жϣTCPģʽЧ*/
   {
       printf("SINT_STAT_CONNECT\r\n");																																																							
   }
   if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
   {
      printf("SINT_STAT_DISCONNECT \r\n");
   }
   if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱжϣTCPģʽЧ */
   {                                                                                                                             
       printf("SINT_STAT_TIM_OUT\r\n");
   }
}

/**********************************************************************************
* Function Name  : CH392GlobalInterrupt
* Description    : CH392ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH392GlobalInterrupt(void)
{
	UINT16  init_status;
	UINT8  buf[10]; 

	init_status = CH392CMDGetGlobIntStatus_ALL();
	if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
	{
	CH392CMDGetUnreachIPPT(buf);                                
	}
	if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH392 IPʼCH392*/
	{
	}
	if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
	{
	printf("Init status : GINT_STAT_PHY_CHANGE\r\n");
	}
		if(init_status & GINT_STAT_DHCP)                           
	{
	printf("Init status : DHCP\r\n");
	}
	if(init_status & GINT_STAT_SOCK0)
	{
	CH392SocketInterrupt(0);                                     /* socket 0ж*/
	}
	if(init_status & GINT_STAT_SOCK1)                               
	{
	CH392SocketInterrupt(1);                                     /* socket 1ж*/
	}
	if(init_status & GINT_STAT_SOCK2)                                
	{
	CH392SocketInterrupt(2);                                     /* socket 2ж*/
	}
	if(init_status & GINT_STAT_SOCK3)                                
	{
	CH392SocketInterrupt(3);                                     /* socket 3ж*/
	}
}

/**********************************************************************************
* Function Name  : CH392Init
* Description    : CH392IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH392Init(void)
{
    UINT8 i;
    
    i = CH392CMDCheckExist(0x65);                      
    if(i != 0x9a)return CH392_ERR_UNKNOW;                            /* ޷ͨ0XFA */
                                                                     /* 0XFAһΪӲ߶дʱ򲻶 */
    CH392CMDSetIPAddr(CH392Inf.IPAddr);                              /* CH392IPַ */
    CH392CMDSetGWIPAddr(CH392Inf.GWIPAddr);                          /* صַ */
    CH392CMDSetMASKAddr(CH392Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/   
    i = CH392CMDInitCH392();                                         /* ʼCH392оƬ */
    return i;
}

/**********************************************************************************
* Function Name  : Gpio_Init
* Description    : IOڳʼ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void Gpio_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOC , ENABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;	    
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;             
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	GPIO_SetBits( GPIOC, GPIO_Pin_8 );                   
}

/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
int main(void)
{
	UINT8 i,ip[4]={0,0,0,0,};
	delay_init();	    	 //ʱʼ	  
	uart_init(115200);	 //ڳʼΪ115200
	CH392_Port_Init();
	Gpio_Init();
	CH392CMDReset();
	delay_ms(100);
	printf("CH392EVT Test Demo\r\n");
	i = CH392CMDGetVer();
	printf("CH392VER : %2x\r\n",(UINT16)i);
	InitCH392InfParam();                                             /* ʼCH392ر */
	i = CH392Init();                                                 /* ʼCH392оƬ */
	mStopIfError(i);
    while(1)
    {                                                                /* ȴ̫ӳɹ*/
       if(CH392CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH392Ƿ */
       {
           delay_ms(200);                                            /* δȴ200MSٴβѯ */
       }
       else 
       {
           printf("CH392 Connect Ethernet\r\n");                       /* CH392оƬӵ̫ʱж */
           break;
       }
    }
		
    while(1)
    {
		if(Query392Interrupt()==0)
		CH392GlobalInterrupt();
		i = DnsQuery(0,url_dn3,ip);                                                         /*ѯ"www.baidu.com"*/
		if(i)
		{ 
		printf("Domain name: %s \n",url_dn3);
		printf(" HTTPs_IP= %d.%d.%d.%d\n\n",ip[0],ip[1],ip[2],ip[3]);
		break;
		}
    }
}



