/********************************** (C) COPYRIGHT *******************************
* File Name          : CH392SPI_HW.C
* Author             : WCH
* Version            : V1.0
* Date               : 2020/02/19
* Description        : CH392оƬ ӲSPIӵӲ V1.0                     
*******************************************************************************/
#include "delay.h"
#include "sys.h"
#include "usart.h"
#include "string.h"
#include "stdio.h"

#define CSL     PAout(2)=0
#define CSH     PAout(2)=1 
#define xCH392CmdStart( )       CSL                       /* ʼ */
#define xEndCH392Cmd( )         CSH                       /* */

/*******************************************************************************
 * Function Name  : CH392_Port_Init
 * Description    : Initializes the port   
 * Input          : None                                 
 * Return         : None
 *******************************************************************************/
void CH392_Port_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	SPI_InitTypeDef  SPI_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |RCC_APB2Periph_SPI1, ENABLE);	

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;             
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_SetBits( GPIOA, GPIO_Pin_2 );                      

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;            
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;           
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;            
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;		
	GPIO_Init( GPIOA, &GPIO_InitStructure );

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_16;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPI1 , &SPI_InitStructure);                           
	SPI_Cmd(SPI1 , ENABLE);                             
}

/*******************************************************************************
 * Function Name  : SPI1_WriteRead
 * Description    : spi дһֽ
 * Input          : u8 Data                               
 * Return         : None
 *******************************************************************************/
u8 SPI1_WriteRead(u8 data)
{
	u8 retry=0;

	while(SPI_I2S_GetFlagStatus(SPI1,SPI_I2S_FLAG_TXE)==RESET)
	{
	  retry++;
		if(retry>200) return 0;
	}
	SPI_I2S_SendData(SPI1,data);
	retry=0;

	while(SPI_I2S_GetFlagStatus(SPI1,SPI_I2S_FLAG_RXNE)==RESET)
	{
	  retry++;
		if(retry>200) return 0;
	}
	return SPI_I2S_ReceiveData(SPI1);	
}

/*******************************************************************************
 * Function Name  : SPI1_MasterTransByte
 * Description    : SPI1 Send One Byte   
 * Input          : u8 Data                               
 * Return         : None
 *******************************************************************************/
void SPI1_MasterTransByte(u8 Data)
{ 
	SPI1_WriteRead(Data);
}

/*******************************************************************************
 * Function Name  : SPI1_MasterRecvByte
 * Description    : SPI1 Receive One Byte   
 * Input          : None                                 
 * Return         : u8 
 *******************************************************************************/
u8 SPI1_MasterRecvByte(void)
{
	return SPI1_WriteRead(0x00);
}

/******************************************************************************
* Function Name  : xWriteCH392Cmd
* Description    : CH392д
* Input          : cmd 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH392Cmd(u8 cmd)                                          
{                                                                    
	xEndCH392Cmd();                                                  /* ֹCSԭΪͣȽCDø */
	xCH392CmdStart( );                                               /* ʼCS */
	SPI1_MasterTransByte(cmd);                                       /* SPI */
	delay_us(10);                                                     /* Ҫʱ,ʱ1.5uSȷдڲС1.5uS */
}

/******************************************************************************
* Function Name  : xWriteCH392Data
* Description    : CH392д
* Input          : mdata 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void  xWriteCH392Data(u8 mdata)
{  
	SPI1_MasterTransByte(mdata);                                     /* SPI */
	delay_us(2); 
}

/*******************************************************************************
* Function Name  : xReadCH392Data
* Description    : CH392
* Input          : None
* Output         : None
* Return         : 8λ
*******************************************************************************/
u8   xReadCH392Data( void )                                                  
{
	u8 i;

	i = SPI1_MasterRecvByte();                                        /* SPI */
	delay_us(2); 
	return i;
}

 
